﻿/*********************************************************************************
source of "nwriter", a basic text-editor for the Nspire; last modified 25.04.11
Copyright (C) 2011 Olivier Thill alias shrear

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program. If not, see <http://www.gnu.org/licenses/>.
*********************************************************************************/

#ifndef _SCREEN_H_
#define _SCREEN_H_


	//prototyps
	void update_buffer(char* store, char* font, int* font_meta, char* screen_buffer, int screen_color, int ycord_start, int xcord_start, int ycord_end, int xcord_end, int index_start, int index) ;
	int update_index(char* store, char* font, int* font_meta, int xcord_start, int xcord_end, short* index_line, int line_number) ;
	int write_char(char character, char* font, int* font_meta, char* screen_buffer, int screen_color, int xcord_start, int ycord_end, int xcord_end, int xcord, int ycord, int write_control) ;
	int write_string(char* string, char* font, int* font_meta, char* screen_buffer, int screen_color, int ycord_start, int xcord_start, int ycord_end, int xcord_end) ;
	int get_offset(char* store, char* font, int* font_meta, int index_start, int index) ;
	int get_index(char* store, char* font, int* font_meta, int offset_x, int line_start, int line_end) ;
	void display_buffer(char* screen_buffer) ;
	int error(int error_id) ;

#endif
